#include <Adafruit_NeoPixel.h>

#define LED_PIN 6
#define LED_COUNT 20

Adafruit_NeoPixel strip(LED_COUNT, LED_PIN);

// C++ code
//
const int force_sensor = A0;
int threshold = 900;  // als de sensor een hogere waarde doorgeeft dan treshold zit er iemand op het kussen

int timer1 = 0;               // timer1 houdt bij hoe lang je op het kussen zit
int timer2 = 0;               // timer2 houdt bij hoe lang je niet op het kussen zit
int timer3 = 0;               // timer3 houdt bij hoe lang je op het kussen bent blijven zitten nadat je eigenllijk al mooet opstaan
int max_initial_health = 20;  // tijd in seconden die aangeeft hoe lang je kan zitten op het kussen voordat de leds rood gaan worden
int max_health = 20;          // tijd in seconden die aangeeft voor hoe lang de ruggengraat steeds roder kan worden
int reset_time = 5;           // tijd in seconden die aangeeft hoe lang je niet op het kussen moet zitten voordat de health bar reset
long last = 0;

void setup() {
  Serial.begin(9600);
  pinMode(force_sensor, INPUT);

  strip.begin();
  strip.fill(strip.Color(255, 255, 255));
  strip.show();  // Maak alle leds wit als het opstart voor de eerste keer
}

void loop() {
  long now = millis();
  int value = analogRead(force_sensor);

  if (now - last > 1000)  // herhaal de volgende code elke seconde
  {
    last = now;
    if (value >= treshold)  // deze code gebeurd wanneer er iemand op het kussen zit
    {
      timer2 = 0;
      timer1 += 1;
      int initial_health = map(timer1, 0, max_initial_health, 0, strip.numPixels());  // initial health houdt bij hoe lang je op het kussen zit voordat je de "gevaren zone" ingaat waar de leds rood worden

      if (timer1 > max_initial_health)  // deze code gebeurd als iemand langer dan een uur (of wat max_initial_health is) op het kussen zit
      {
        timer3 += 1;
        int health = map(timer3, 0, max_health, 0, strip.numPixels());  // health houd bij hoe lang je op het kussen zit nadat je er al te lang op heb gezeten
        strip.fill(strip.Color(255, 0, 0), 0, health);                  // Maakt een aantal leds bepaalt door de health waarde rood
        strip.show();
      } else {
        strip.fill(strip.Color(0, 0, 255), 0, initial_health);  // maakt een aantal leds blauw bepaald door de initial health waarde
        strip.show();
      }
    } else {
      timer2 += 1;
      if (timer2 >= reset_time)  // reset de timer als je langer dan reset_time niet op het kussen heb gezeten
      {
        timer1 = 0;
        timer2 = 0;
        timer3 = 0;
        strip.fill(strip.Color(255, 255, 255));
        strip.show();
      }
    }
  }
}